# test password: start_rdp "rdpp://Test01!@testuser01@192.168.205.105/"
# test token without proxy: start_rdp "rdpp://token=ttt@testuser01@192.168.205.105/"
# test token with proxy: start_rdp "rdpp://token=ttt@testuser01@192.168.205.105@192.168.205.110"

import sys
import os
import subprocess


MSTSC_CLIENT_EXE = 'mstsc.exe'
GENCRYPT_EXE = 'gencrypt.exe'


if len(sys.argv) != 2:
    print('command arguments: <url>')
    sys.exit(-1)

url = sys.argv[1].strip()[7:]
if url[-1] == '/':
    url = url[:-1]
params = url.split('@')

passwd = None
if params[0].startswith('token'):
    if len(params) not in (3, 4):
        print('3 or 4 paramaters needed for rdp with token')
        sys.exit(-1)
    token = params[0]
    host = params[-1]
    user = '%'.join(params[1:-1])
else:
    if len(params) not in (2, 3):
        print('2 or 3 paramaters needed for rdp without token')
        sys.exit(-1)
    if len(params) == 3:
        passwd = params[0]
    host = params[-1]
    user = params[-2]

rdp_file_name = 'conn.rdp'
with open(rdp_file_name, "w") as rdp_file:
    rdp_file.write(f'username:s:{user}\n')
    rdp_file.write(f'full address:s:{host}\n')
    if passwd:
        try:
            encrypted = subprocess.check_output(f'{GENCRYPT_EXE} /p:{passwd} /hash').decode('ascii')
        except subprocess.CalledProcessError as exc:
            print('Error encrypting password', exc)
            sys.exit(-1)
        rdp_file.write(encrypted)


subprocess.Popen(f'{MSTSC_CLIENT_EXE} {rdp_file_name}')
